// SwingMenu.java
//
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SwingMenu extends JMenuBar {

   String[ ] optMenFic = new String[ ] { "Nouveau", "Ouvrir", "Sauver", "Quitter" };
   String[ ] optMenEdi = new String[ ] { "Annuler", "Couper", "Copier", "Coller" };
   char[ ] raccouMenFic = { 'N','O','S','Q' };
   char[ ] raccouMenEdi = { 'Z','X','C','V' };

   public SwingMenu(  ) {

      JMenu menuFic = new JMenu("Fichier");
      JMenu menuEdi = new JMenu("Edition");
      JMenu menuAut = new JMenu("Autre");
      JMenu menuSub1  = new JMenu("Sous-menu");
      JMenu menuSub2  = new JMenu("Sous-menu2");

      ActionListener printListener = new ActionListener(  ) {
         public void actionPerformed(ActionEvent event) {
            System.out.println("Option choisie [" + event.getActionCommand(  ) + "].");
         }
      };
      // Construction du menu Fichier avec raccourcis clavier
      for (int i=0; i < optMenFic.length; i++) {
         JMenuItem item = new JMenuItem(optMenFic[i], raccouMenFic[i]);
         item.addActionListener(printListener);
         menuFic.add(item);
      }

      // Construction du menu Edition avec raccourcis clavier
      for (int i=0; i < optMenEdi.length; i++) {
         JMenuItem item = new JMenuItem(optMenEdi[i]);
         item.setAccelerator(KeyStroke.getKeyStroke(raccouMenEdi[i],
              Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
         item.addActionListener(printListener);
         menuEdi.add(item);
      }

      // Ajout de ligne horizontale dans le menu Edition
      menuEdi.insertSeparator(1);

      // Construction des sous-menus de Autre
      JMenuItem item;
      menuSub2.add(item = new JMenuItem("Bonus 2"));
      item.addActionListener(printListener);
      menuSub1.add(item = new JMenuItem("Bonus 1"));
      item.addActionListener(printListener);
      menuSub1.add(menuSub2);

      // Construction du menu Autre
      menuAut.add(menuSub1);
      menuAut.add(item = new JCheckBoxMenuItem("Essayez-moi"));
      item.addActionListener(printListener);
      menuAut.addSeparator(  );
      ButtonGroup buttonGroup = new ButtonGroup(  );
      menuAut.add(item = new JRadioButtonMenuItem("Bouton radio 1"));
      item.addActionListener(printListener);
      buttonGroup.add(item);
      menuAut.add(item = new JRadioButtonMenuItem("Bouton radio 2"));
      item.addActionListener(printListener);
      buttonGroup.add(item);
      menuAut.addSeparator(  );
      menuAut.add(item = new JMenuItem("Option illustre", 
                           new ImageIcon("image.gif")));
      item.addActionListener(printListener);

      // Injection de tous les menus dans la barre de menus
      add(menuFic);
      add(menuEdi);
      add(menuAut);
   }

   public static void main(String s[ ]) {
      JFrame frame = new JFrame("Exemple de menu Swing");
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      frame.setJMenuBar(new SwingMenu(  ));
      JLabel label = new JLabel(" Bienvenue dans Java (SwingMenu.java)");
      frame.getContentPane().add(label);
      frame.pack(  );
      frame.setSize(500, 300);
      frame.setVisible(true);
   }
}